# Generated by go2rpm
%bcond_without check

# https://github.com/godoctor/godoctor
%global goipath         github.com/godoctor/godoctor
Version:                0.7

%gometa

%global common_description %{expand:
Go Doctor - The Golang Refactoring Engine.}

%global golicenses      LICENSE
%global godocs          doc README.md

Name:           godoctor
Release:        %autorelease
Summary:        A golang refactoring tool

# Upstream license specification: BSD-3-Clause
License:        BSD-3-Clause
URL:            %{gourl}
Source0:        %{gosource}
# https://github.com/godoctor/godoctor/pull/61
Patch:          0001-Add-missing-error-handlers-to-tests.patch
# https://github.com/godoctor/godoctor/pull/62
Patch:          0002-Normalize-paths-in-TestFindOccurrences.patch
# https://github.com/godoctor/godoctor/pull/63
Patch:          0003-Merge-pull-request-63-from-godoctor-fix-tests-1-20.patch
# Fedora specific
Patch:          0004-Skip-occurrence-test-that-uses-modules.patch
# https://github.com/godoctor/godoctor/issues/60#issuecomment-1450973808
Patch:          0005-Skip-tests-that-appear-to-be-broken.patch
# https://github.com/godoctor/godoctor/pull/64
Patch:          0006-Copy-existing-environment-when-loading-packages.patch
# For under Go 1.20
Patch:          0007-Revert-patch-to-showast-debug-output.patch

BuildRequires:  golang(github.com/willf/bitset)
BuildRequires:  golang(golang.org/x/tools/go/ast/astutil)
BuildRequires:  golang(golang.org/x/tools/go/loader)

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1 -M 5
%if %{fedora} < 38
%autopatch -p1 6
%endif

%build
%gobuild -o %{gobuilddir}/bin/godoctor %{goipath}

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
#export GOCACHE="${PWD}/$(mktemp -d godoctor.XXXXXX)"
%global gotestflags %{gotestflags} -timeout 60m
%gocheck
%endif

%files
%doc README.md
%license LICENSE
%{_bindir}/godoctor

%gopkgfiles

%changelog
%autochangelog
